Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.om
Interface NodeInfo

All Superinterfaces:
  Item<NodeInfo>, PullEvent, Source, ValueRepresentation<NodeInfo>

All Known Subinterfaces:
  DocumentInfo, MutableNodeInfo, SiblingCountingNode, VirtualNode

All Known Implementing Classes:
  AbsentExtensionElement, AbstractVirtualNode, AnnotationParent, DataElement, DocumentImpl, DocumentWrapper, DocumentWrapper, DocumentWrapper, DocumentWrapper, ElementImpl, ExtensionInstruction, FleetingDocumentNode, FleetingElementNode, FleetingNode, LiteralResultElement, NamespaceNode, NodeImpl, NodeWrapper, NodeWrapper, NodeWrapper, NodeWrapper, Orphan, SaxonAssign, SaxonCallTemplate, SaxonCollation, SaxonDoctype, SaxonEntityRef, SaxonImportQuery, SaxonParam, SaxonPreprocess, SaxonWhile, SchemaElement, SpaceStrippedDocument, SpaceStrippedNode, SQLClose, SQLColumn, SQLConnect, SQLDelete, SQLExecute, SQLInsert, SQLQuery, SQLUpdate, StyleElement, TextFragmentValue, TinyDocumentImpl, TinyElementImpl, TinyNodeImpl, TinyParentNodeImpl, TinyTextImpl, TypeStrippedDocument, TypeStrippedNode, UnconstructedDocument, UnconstructedElement, UnconstructedParent, UnknownElement, VirtualCopy, VirtualDocumentCopy, VirtualUntypedCopy, WhitespaceTextImpl, XSDAlternative, XSDAnnotation, XSDAny, XSDAnyAttribute, XSDAssert, XSDAttribute, XSDAttributeGroup, XSDComplexContent, XSDComplexContentRestriction, XSDComplexType, XSDCompositor, XSDDefaultOpenContent, XSDDocumentation, XSDElement, XSDExtension, XSDFacet, XSDFieldOrSelector, XSDGroup, XSDIdentityConstraint, XSDImport, XSDInclude, XSDList, XSDNotation, XSDOpenContent, XSDOverride, XSDRedefine, XSDSchema, XSDSimpleContent, XSDSimpleContentRestriction, XSDSimpleType, XSDSimpleTypeRestriction, XSDUnion, XSLAnalyzeString, XSLApplyImports, XSLApplyTemplates, XSLAttribute, XSLAttributeSet, XSLBreak, XSLBreakOrContinue, XSLCallTemplate, XSLCatch, XSLCharacterMap, XSLChoose, XSLComment, XSLCopy, XSLCopyOf, XSLDecimalFormat, XSLDocument, XSLElement, XSLEvaluate, XSLFallback, XSLForEach, XSLForEachGroup, XSLFork, XSLFunction, XSLGeneralIncorporate, XSLGeneralVariable, XSLIf, XSLImport, XSLImportSchema, XSLInclude, XSLIterate, XSLKey, XSLLeafNodeConstructor, XSLMatchingSubstring, XSLMerge, XSLMergeAction, XSLMergeInput, XSLMergeKey, XSLMergeSource, XSLMessage, XSLMode, XSLNamespace, XSLNamespaceAlias, XSLNextIteration, XSLNextMatch, XSLNumber, XSLOnCompletion, XSLOtherwise, XSLOutput, XSLOutputCharacter, XSLParam, XSLPerformSort, XSLPreserveSpace, XSLProcessingInstruction, XSLResultDocument, XSLSequence, XSLSort, XSLSortOrMergeKey, XSLStylesheet, XSLTemplate, XSLText, XSLTry, XSLValueOf, XSLVariable, XSLVariableDeclaration, XSLWhen, XSLWithParam

    public interface NodeInfo

extends Source, Item<NodeInfo>, ValueRepresentation<NodeInfo>

The NodeInfo interface represents a node in Saxon's implementation of the XPath 2.0 data model.

Note that several NodeInfo objects may represent the same node. To test node identity, the method `isSameNodeInfo(NodeInfo)` should be used. An exception to this rule applies for document nodes, where the correspondence between document nodes and DocumentInfo objects is one to one. NodeInfo objects are never reused: a given NodeInfo object represents the same node for its entire lifetime.

This is the primary interface for accessing trees in Saxon, and it forms part of the public Saxon API. The only subclass of NodeInfo that applications should normally use is `DocumentInfo`, which represents a document node. Methods that form part of the public API are (since Saxon 8.4) labelled with a JavaDoc "since" tag: classes and methods that have no such label should not be regarded as stable interfaces.

The interface represented by this class is at a slightly higher level than the abstraction described in the W3C data model specification, in that it includes support for the XPath axes, rather than exposing the lower-level properties (such as "parent" and "children") directly. All navigation within trees, except for a few convenience methods, is done by following the axes using the `iterateAxis(byte)` method. This allows different implementations of the XPath tree model to implement axis navigation in different ways. Some implementations may choose to use the helper methods provided in class `Navigator`.

Note that the stability of this interface applies to classes that use the interface, not to classes that implement it. The interface may be extended in future to add new methods.

New implementations of NodeInfo are advised also to implement the methods in interface ExtendedNodeInfo, which will be moved into this interface at some time in the future.

Since:
  8.4. Extended with three extra methods, previously in ExtendedNodeInfo, in 9.1
Author:
  Michael H. Kay

Field Summary
`static int` | `ALL_NAMESPACES` Copy all in-scope namespaces
`static int` | `IS_DTD_TYPE` Bit setting in the returned type annotation indicating a DTD_derived type on an attribute node
`static int` | `IS_NILLED` Bit setting for use alongside a type annotation indicating that the is-nilled property is set
`static int` | `LOCAL_NAMESPACES` Copy namespaces declared (or undeclared) on this element, but not namespaces inherited from a parent element
`static int` | `NO_NAMESPACES` Don't copy any namespace nodes.

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Method Summary
`Value` | `atomize()` Get the typed value.
`int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`void` | `copy(Receiver out, int copyOptions, int locationId)` Copy this node to a given Receiver.
`boolean` | `equals(Object other)` The equals() method compares nodes for identity.
`void` | `generateId(FastStringBuffer buffer)` Construct a character string that uniquely identifies this node.
`String` | `getAttributeValue(int fingerprint)` Get the string value of a given attribute of this node
`String` | `getAttributeValue(String uri, String local)` Get the string value of a given attribute of this node
`String` | `getBaseURI()` Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
`int` | `getColumnNumber()` Get column number.
`Configuration` | `getConfiguration()` Get the configuration used to build the tree containing this node.
`NamespaceBinding[]` | `getDeclaredNamespaces(NamespaceBinding[] buffer)` Get all namespace declarations and undeclarations defined on this element.
`String` | `getDisplayName()` Get the display name of this node, in the form of a lexical QName.
`long` | `getDocumentNumber()` Get the document number of the document containing this node.
`DocumentInfo` | `getDocumentRoot()` Get the root node, if it is a document node.
`int` | `getFingerprint()` Get fingerprint.
`int` | `getLineNumber()` Get line number.
`String` | `getLocalPart()` Get the local part of the name of this node.
`int` | `getNameCode()` Get name code.
`NamePool` | `getNamePool()` Get the NamePool that holds the namecode for this node
`int` | `getNodeKind()` Get the kind of node.
`NodeInfo` | `getParent()` Get the NodeInfo object representing the parent of this node
`String` | `getPrefix()` Get the prefix of the name of the node.
`NodeInfo` | `getRoot()` Get the root node of the tree containing this node
`SchemaType` | `getSchemaType()` Get the type annotation of this node, if any.
`String` | `getStringValue()` Return the string value of the node as defined in the XPath data model.
`String` | `getSystemId()` Get the System ID for the node.
`int` | `getTypeAnnotation()` Get the type annotation of this node, if any.
`String` | `getURI()` Get the URI part of the name of this node.
`boolean` | `hasChildNodes()` Determine whether the node has any children.
`int` | `hashCode()` The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
`boolean` | `isId()` Determine whether this node has the is-id property
`boolean` | `isIdref()` Determine whether this node has the is-idref property
`boolean` | `isNilled()` Determine whether the node has the is-nilled property
`boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node.
`AxisIterator` | `iterateAxis(byte axisNumber)` Return an iteration over all the nodes reached by the given axis from this node
`AxisIterator` | `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest

Methods inherited from interface javax.xml.transform.Source
`setSystemId`

Methods inherited from interface net.sf.saxon.om.Item
`getStringValueCS, getTypedValue`

Field Detail

### IS_DTD_TYPE

    static final int IS_DTD_TYPE

  Bit setting in the returned type annotation indicating a DTD_derived type on an attribute node

  See Also:
    Constant Field Values

### IS_NILLED

    static final int IS_NILLED

  Bit setting for use alongside a type annotation indicating that the is-nilled property is set

  See Also:
    Constant Field Values

### NO_NAMESPACES

    static final int NO_NAMESPACES

  Don't copy any namespace nodes.

  See Also:
    Constant Field Values

### LOCAL_NAMESPACES

    static final int LOCAL_NAMESPACES

  Copy namespaces declared (or undeclared) on this element, but not namespaces inherited from a parent element

  See Also:
    Constant Field Values

### ALL_NAMESPACES

    static final int ALL_NAMESPACES

  Copy all in-scope namespaces

  See Also:
    Constant Field Values

Method Detail

### getNodeKind

    int getNodeKind()

  Get the kind of node. This will be a value such as `Type.ELEMENT` or `Type.ATTRIBUTE`. There are seven kinds of node: documents, elements, attributes, text, comments, processing-instructions, and namespaces.

  Returns:
    an integer identifying the kind of node. These integer values are the same as those used in the DOM
  Since:
    8.4
  See Also:
    `Type`

### isSameNodeInfo

    boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node.

  Note that two different NodeInfo instances can represent the same conceptual node. Therefore the "==" operator should not be used to test node identity. The equals() method should give the same result as isSameNodeInfo(), but since this rule was introduced late it might not apply to all implementations.

  Note: a.isSameNodeInfo(b) if and only if generateId(a)==generateId(b).

  This method has the same semantics as isSameNode() in DOM Level 3, but works on Saxon NodeInfo objects rather than DOM Node objects.

  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.

### equals

    boolean equals(Object other)

  The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().

  Overrides:
    `equals` in class `Object`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
  Since:
    8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

### hashCode

    int hashCode()

  The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()

  Overrides:
    `hashCode` in class `Object`
  Since:
    8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

### getSystemId

    String getSystemId()

  Get the System ID for the node. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot. The base URI is used primarily for resolving relative URIs within the content of the document. The system ID is used primarily in conjunction with a line number, for identifying the location of elements within the source XML, in particular when errors are found. For a document node, the System ID represents the value of the document-uri property as defined in the XDM data model.

  Specified by:
    `getSystemId` in interface `Source`
  Returns:
    the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.
  Since:
    8.4

### getBaseURI

    String getBaseURI()

  Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. This will be the same as the System ID unless xml:base has been used. Where the node does not have a base URI of its own, the base URI of its parent node is returned.

  Returns:
    the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.
  Since:
    8.4

### getLineNumber

    int getLineNumber()

  Get line number. Line numbers are not maintained by default, except for stylesheets and schema documents. Line numbering can be requested using the -l option on the command line, or by setting options on the TransformerFactory or the Configuration before the source document is built.

  The granularity of line numbering is normally the element level: for other nodes such as text nodes and attributes, the line number of the parent element will normally be returned.

  In the case of a tree constructed by taking input from a SAX parser, the line number will reflect the SAX rules: that is, the line number of an element is the line number where the start tag ends. This may be a little confusing where elements have many attributes spread over multiple lines, or where single attributes (as can easily happen with XSLT 2.0 stylesheets) occupy several lines.

  In the case of a tree constructed by a stylesheet or query, the line number may reflect the line in the stylesheet or query that caused the node to be constructed.

  The line number can be read from within an XPath expression using the Saxon extension function saxon:line-number()

  Returns:
    the line number of the node in its original source document; or -1 if not available
  Since:
    8.4

### getColumnNumber

    int getColumnNumber()

  Get column number. Column numbers are not maintained by default. Column numbering can be requested in the same way as line numbering; but a tree implementation can ignore the request.

  The granularity of column numbering is normally the element level: for other nodes such as text nodes and attributes, the line number of the parent element will normally be returned.

  In the case of a tree constructed by taking input from a SAX parser, the column number will reflect the SAX rules: that is, the column number of an element is the column number where the start tag ends. This may be a little confusing where elements have many attributes spread over multiple lines, or where single attributes (as can easily happen with XSLT 2.0 stylesheets) occupy several lines.

  In the case of a tree constructed by a stylesheet or query, the column number may reflect the line in the stylesheet or query that caused the node to be constructed.

  The column number can be read from within an XPath expression using the Saxon extension function saxon:column-number()

  Returns:
    the column number of the node in its original source document; or -1 if not available
  Since:
    9.1

### compareOrder

    int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order.

  The other node must always be in the same tree; the effect of calling this method when the two nodes are in different trees is undefined. To obtain a global ordering of nodes, the application should first compare the result of getDocumentNumber(), and only if the document number is the same should compareOrder() be called.

  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())
  Since:
    8.4

### getStringValue

    String getStringValue()

  Return the string value of the node as defined in the XPath data model.

  The interpretation of this depends on the type of node. For an element it is the accumulated character content of the element, including descendant elements.

  This method returns the string value as if the node were untyped. Unlike the string value accessor in the XPath 2.0 data model, it does not report an error if the element has a complex type, instead it returns the concatenation of the descendant text nodes as it would if the element were untyped.

  Specified by:
    `getStringValue` in interface `Item<NodeInfo>`
  Specified by:
    `getStringValue` in interface `ValueRepresentation<NodeInfo>`
  Returns:
    the string value of the node
  Since:
    8.4
  See Also:
    `Item.getStringValueCS()`

### getNameCode

    int getNameCode()

  Get name code. The name code is a coded form of the node name: two nodes with the same name code have the same namespace URI, the same local name, and the same prefix. By masking the name code with `NamePool.FP_MASK`, you get a fingerprint: two nodes with the same fingerprint have the same local name and namespace URI.

  Returns:
    an integer name code, which may be used to obtain the actual node name from the name pool. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
  Since:
    8.4
  See Also:
    `allocate`, `getFingerprint`

### getFingerprint

    int getFingerprint()

  Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. The fingerprint contains no information about the namespace prefix. For a name in the null namespace, the fingerprint is the same as the name code.

  Returns:
    an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
  Since:
    8.4

### getLocalPart

    String getLocalPart()

  Get the local part of the name of this node. This is the name after the ":" if any.

  Returns:
    the local part of the name. For an unnamed node, returns "". Unlike the DOM interface, this returns the full name in the case of a non-namespaced name.
  Since:
    8.4

### getURI

    String getURI()

  Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.

  Returns:
    The URI of the namespace of this node. For an unnamed node, or for an element or attribute that is not in a namespace, or for a processing instruction, returns an empty string.
  Since:
    8.4

### getDisplayName

    String getDisplayName()

  Get the display name of this node, in the form of a lexical QName. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.

  Returns:
    The display name of this node. For a node with no name, returns an empty string.
  Since:
    8.4

### getPrefix

    String getPrefix()

  Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, returns a zero-length string.

  Returns:
    The prefix of the name of the node.
  Since:
    8.4

### getConfiguration

    Configuration getConfiguration()

  Get the configuration used to build the tree containing this node.

  Returns:
    the Configuration
  Since:
    8.4

### getNamePool

    NamePool getNamePool()

  Get the NamePool that holds the namecode for this node

  Returns:
    the namepool
  Since:
    8.4

### getTypeAnnotation

    int getTypeAnnotation()

  Get the type annotation of this node, if any. The type annotation is represented as an integer; this is the fingerprint of the name of the type, as defined in the name pool. Anonymous types are given a system-defined name. The value of the type annotation can be used to retrieve the actual schema type definition using the method `Configuration.getSchemaType(int)`.

  The bit IS_DTD_TYPE (1<<30) will be set in the case of an attribute node if the type annotation is one of ID, IDREF, or IDREFS and this is derived from DTD rather than schema validation.

  Returns:
    the type annotation of the node, under the mask NamePool.FP_MASK, and optionally the bit setting IS_DTD_TYPE in the case of a DTD-derived ID or IDREF/S type (which is treated as untypedAtomic for the purposes of obtaining the typed value).

    For elements and attributes, this is the type annotation as defined in XDM. For document nodes, it should be one of XS_UNTYPED if the document has not been validated, or XS_ANY_TYPE if validation has taken place (that is, if any node in the document has an annotation other than Untyped or UntypedAtomic).

  Since:
    8.4. Refinement for document nodes introduced in 9.2

### getSchemaType

    SchemaType getSchemaType()

  Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

  Types derived from a DTD are not reflected in the result of this method.

  Returns:
    For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
  Since:
    9.4

### atomize

    Value atomize()
                  throws XPathException

  Get the typed value. The result of this method will always be consistent with the method `Item.getTypedValue()`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Returns:
    the typed value. This will either be a single AtomicValue or a Value whose items are atomic values.
  Throws:
    `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
  Since:
    8.5

### getParent

    NodeInfo getParent()

  Get the NodeInfo object representing the parent of this node

  Returns:
    the parent of this node; null if this node has no parent
  Since:
    8.4

### iterateAxis

    AxisIterator iterateAxis(byte axisNumber)

  Return an iteration over all the nodes reached by the given axis from this node

  Parameters:
    `axisNumber` - an integer identifying the axis; one of the constants defined in class `Axis`
  Returns:
    an AxisIterator that delivers the nodes reached by the axis in turn. The nodes are returned in axis order (document order for a forwards axis, reverse document order for a reverse axis).
  Throws:
    `UnsupportedOperationException` - if the namespace axis is requested and this axis is not supported for this implementation.
  Since:
    8.4
  See Also:
    `Axis`

### iterateAxis

    AxisIterator iterateAxis(byte axisNumber,
                             NodeTest nodeTest)

  Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest

  Parameters:
    `axisNumber` - an integer identifying the axis; one of the constants defined in class `Axis`
    `nodeTest` - A condition to be satisfied by the returned nodes; nodes that do not satisfy this condition are not included in the result
  Returns:
    an AxisIterator that delivers the nodes reached by the axis in turn. The nodes are returned in axis order (document order for a forwards axis, reverse document order for a reverse axis).
  Throws:
    `UnsupportedOperationException` - if the namespace axis is requested and this axis is not supported for this implementation.
  Since:
    8.4
  See Also:
    `Axis`

### getAttributeValue

    String getAttributeValue(int fingerprint)

  Get the string value of a given attribute of this node

  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
  Since:
    8.4

### getAttributeValue

    String getAttributeValue(String uri,
                             String local)

  Get the string value of a given attribute of this node

  Parameters:
    `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
    `local` - the local part of the attribute name.
  Returns:
    the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
  Since:
    9.4

### getRoot

    NodeInfo getRoot()

  Get the root node of the tree containing this node

  Returns:
    the NodeInfo representing the top-level ancestor of this node. This will not necessarily be a document node. If this node has no parent, then the method returns this node.
  Since:
    8.4

### getDocumentRoot

    DocumentInfo getDocumentRoot()

  Get the root node, if it is a document node.

  Returns:
    the DocumentInfo representing the containing document. If this node is part of a tree that does not have a document node as its root, returns null.
  Since:
    8.4

### hasChildNodes

    boolean hasChildNodes()

  Determine whether the node has any children.

  Note: the result is equivalent to
  `iterateAxis(Axis.CHILD).next() != null`

  Returns:
    True if the node has one or more children
  Since:
    8.4

### generateId

    void generateId(FastStringBuffer buffer)

  Construct a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)

  Parameters:
    `buffer` - a buffer which will be updated to hold a string that uniquely identifies this node, across all documents.
  Since:
    8.7

    Changed in Saxon 8.7 to generate the ID value in a client-supplied buffer

### getDocumentNumber

    long getDocumentNumber()

  Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.

  Returns:
    the document number of the document containing this node
  Since:
    8.4

### copy

    void copy(Receiver out,
              int copyOptions,
              int locationId)
              throws XPathException

  Copy this node to a given Receiver.

  This method is primarily for internal use. It should not be considered a stable part of the Saxon API.

  Parameters:
    `out` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
    `copyOptions` - a selection of the options defined in `CopyOptions`
    `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
  Throws:
    `XPathException` - if any downstream error occurs

### getDeclaredNamespaces

    NamespaceBinding[] getDeclaredNamespaces(NamespaceBinding[] buffer)

  Get all namespace declarations and undeclarations defined on this element.

  This method is intended primarily for internal use. User applications needing information about the namespace context of a node should use `iterateAxis(Axis.NAMESPACE)`. (However, not all implementations support the namespace axis, whereas all implementations are required to support this method.)

  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### isId

    boolean isId()

  Determine whether this node has the is-id property

  Returns:
    true if the node is an ID

### isIdref

    boolean isIdref()

  Determine whether this node has the is-idref property

  Returns:
    true if the node is an IDREF or IDREFS element or attribute

### isNilled

    boolean isNilled()

  Determine whether the node has the is-nilled property

  Returns:
    true if the node has the is-nilled property

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.